import sys

# Add the Yoctopuce library path
sys.path.append(r"C:\data\tmp\YoctoLib.python.62875\Sources")

from yocto_api import *

def initialize_modules():
    errmsg = YRefParam()
    if YAPI.RegisterHub("usb", errmsg) != YAPI.SUCCESS:
        print(f"Initialization error: {errmsg.value}")
        sys.exit(1)

def list_devices():
    module = YModule.FirstModule()
    if not module:
        print("No Yoctopuce modules detected.")
        return

    print("Connected Yoctopuce modules:")
    while module:
        print(f" - {module.get_serialNumber()} ({module.get_productName()})")
        module = module.nextModule()

if __name__ == "__main__":
    initialize_modules()
    try:
        list_devices()
    except KeyboardInterrupt:
        print("\nExiting program.")
    finally:
        YAPI.FreeAPI()
