
# Application Graphique Yocto-Meteo-V2 et Yocto-MaxiPowerRelay

Cette application graphique utilise **Yoctopuce Yocto-Meteo-V2** pour mesurer la température et **Yocto-MaxiPowerRelay** pour contrôler un relais en fonction de la température.

## Fonctionnalités

- **Affichage en temps réel de la température** mesurée par le Yocto-Meteo-V2.
- **Contrôle automatique du relais** :
  - Le relais s'ouvre (bornes non en contact) si la température dépasse **25°C**.
  - Le relais se ferme (bornes en contact) si la température est inférieure ou égale à **25°C**.
- **Support du hot-plug** :
  - Si un module est débranché, l'application continue de fonctionner et tente de redétecter les modules automatiquement.
- **Interface utilisateur simple** :
  - Température et état du relais affichés.
  - Bouton "Quitter" pour fermer proprement l'application.

## Prérequis

Avant d'exécuter cette application, assurez-vous d'avoir les éléments suivants :

1. **Modules Yoctopuce** :
   - [Yocto-Meteo-V2](https://www.yoctopuce.com/FR/products/yocto-meteo-v2)
   - [Yocto-MaxiPowerRelay](https://www.yoctopuce.com/FR/products/yocto-maxipowerrelay)
2. **Python** :
   - Version 3.7 ou supérieure.
3. **Bibliothèques Yoctopuce** :
   - Téléchargez la bibliothèque Python Yoctopuce depuis [Yoctopuce Downloads](https://www.yoctopuce.com/FR/downloads) et placez les fichiers dans le répertoire de votre projet.
4. **Fichier `yapi64.dll`** (ou `yapi.dll` pour Windows 32 bits) :
   - Assurez-vous que ce fichier est dans un répertoire accessible par le script (par exemple, un sous-dossier `cdll`).

## Installation

1. Clonez ce dépôt GitHub :
   ```bash
   git clone https://github.com/votre-utilisateur/yocto-app.git
   cd yocto-app
   ```

2. Installez les dépendances nécessaires :
   - Placez la bibliothèque Yoctopuce (`yocto_api.py`, etc.) dans le répertoire du projet.

3. Branchez vos modules Yoctopuce aux ports USB de votre ordinateur.

## Utilisation

1. Lancez l'application avec Python :
   ```bash
   python app_graphique.py
   ```

2. Une fenêtre s'ouvrira, affichant :
   - La température mesurée en temps réel.
   - L'état du relais (ouvert/fermé).

3. Si un module est débranché, l'application affichera un message d'erreur et tentera de reconnecter les modules automatiquement.

## Démonstration

![Capture d'écran de l'application](screenshot.png)

## Structure du projet

```
yocto-app/
│
├── app_graphique.py       # Script principal de l'application
├── yocto_api.py           # Bibliothèque Yoctopuce
├── yocto_temperature.py   # Module Yoctopuce pour le capteur de température
├── yocto_relay.py         # Module Yoctopuce pour le relais
├── cdll/                  # Contient le fichier yapi64.dll
└── README.md              # Ce fichier
```

## Notes supplémentaires

- L'application est configurée pour fonctionner avec un relais ayant l'identifiant **MXPWRRLY-45C5B.relay1**. Si votre relais a un identifiant différent, vous devrez le modifier dans le code.
- Cette application est développée et testée sur Windows. Si vous utilisez un autre système d'exploitation, veuillez consulter la documentation Yoctopuce pour les ajustements nécessaires.

## Contribuer

Les contributions sont les bienvenues ! Si vous avez des idées pour améliorer l'application, n'hésitez pas à créer une _issue_ ou à soumettre une _pull request_.

## Licence

[MIT](LICENSE)
```
